'use strict';const CONTENT_EVENT='mozMobileIdContentEvent';const CHROME_EVENT='mozMobileIdChromeEvent';const UNSOLICITED_EVENT='mozMobileIdUnsolContentEvent';var MobileIdManager={dialog:null,init:function mobileid_init(){window.addEventListener(CHROME_EVENT,this.onChromeEvent.bind(this));},onChromeEvent:function mobileid_onChromeEvent(event){if(!event||!event.detail){console.error('Wrong event');return;}
var message=event.detail;var params=message.data;if(message.id){this.chromeEventId=message.id;}
switch(message.eventName){case'onpermissionrequest':if(this.dialog){return;}
this.openDialog(params);break;default:if(!this.dialog){return;}
this.dialog.dispatchEvent(message.eventName,params);break;}},cleanup:function mobileid_cleanup(){if(this.dialog){this.dialog.reset();this.dialog=null;}
if(this.chromeEventId){this.sendContentEvent(CONTENT_EVENT,{id:this.chromeEventId,error:'DIALOG_CLOSED_BY_USER'});this.chromeEventId=null;}},cancel:function mobileid_cancel(isVerificationDone){this.cleanup();if(!isVerificationDone){this.sendContentEvent(UNSOLICITED_EVENT,{eventName:'cancel'});}},close:function mobileid_close(isVerificationDone){if(!this.dialog){return;}
this.dialog.close(this.cancel.bind(this,isVerificationDone));},sendMsisdn:function mobileid_close(msisdnSelected){this.sendContentEvent(CONTENT_EVENT,{id:this.chromeEventId||null,result:msisdnSelected});},sendVerificationCode:function mobileid_sendVerificationCode(code){this.sendContentEvent(CONTENT_EVENT,{id:this.chromeEventId||null,result:{verificationCode:code||''}});},requestNewCode:function mobileid_askForNewCode(){this.sendContentEvent(UNSOLICITED_EVENT,{eventName:'resendcode'});},sendContentEvent:function mobileid_sendContentEvent(eventName,msg){var event=new CustomEvent(eventName,{detail:msg});window.dispatchEvent(event);},openDialog:function mobileid_openDialog(params){var app=applications.getByManifestURL(params.manifestURL);if(!app){this.cancel(false);console.error('App is not available when requesting Mobile ID');return;}
var dialogOptions={onHide:this.cleanup.bind(this),onLoaded:function onLoaded(){this.dialog.dispatchEvent('init',{appName:app.manifest.name,candidates:params.phoneNumberInfo});}.bind(this)};this.dialog=new MobileIdDialog(dialogOptions);}};MobileIdManager.init();